unit brow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WebIndi, ExtCtrls, WebNav, ComCtrls, StdCtrls, Menus, Webproxy,
  HTMLProc, Tabnotbk, Tabs, Inifiles, Proxyd, WebBrow, Webcache, WebImage,
  WebPrint, Request, Web, Unkn, Source, Save, Prg, SaveDoc, Search,
  WebMemory;

type
  TMainForm = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenFile1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Panel2: TPanel;
    WebProxy1: TWebProxy;
    Bevel2: TBevel;
    OpenDialog1: TOpenDialog;
    Options1: TMenuItem;
    ProxySetting1: TMenuItem;
    Panel1: TPanel;
    Panel3: TPanel;
    WebPrinter1: TWebPrinter;
    PrintPreview1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    WebNavigator1: TWebNavigator;
    Surface: TWebBrowser;
    WebIndicator1: TWebIndicator;
    WebCache1: TWebCache;
    ShowImages1: TMenuItem;
    ShowToolBar1: TMenuItem;
    Edit1: TMenuItem;
    ShowSourceCode1: TMenuItem;
    SaveDocument1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Panel4: TPanel;
    B1: TButton;
    B2: TButton;
    B3: TButton;
    B4: TButton;
    B5: TButton;
    ShowToolBar2: TMenuItem;
    Label1: TLabel;
    Memo1: TMemo;
    ShowHeader1: TMenuItem;
    ClearCache1: TMenuItem;
    FindWord1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrinterSetup1: TMenuItem;
    ShowStatusbar1: TMenuItem;
    WebMemory1: TWebMemory;
    procedure WebNavigator2Click(Sender: TObject; Button: TWebNavigateBtn);
    procedure SurfaceConnected(Sender: TObject; URL : string);
    procedure SurfaceURL(Sender: TObject);
    procedure SurfaceURLClick(Sender: TObject);
    procedure SurfaceDisconnected(Sender: TObject);
    procedure SurfaceTitle(Sender: TObject; DocumentTitle: string);
    procedure OpenFile1Click(Sender: TObject);
    procedure ProxySetting1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintPreview1Click(Sender: TObject);
    procedure SurfaceMailRequest(Sender: TObject; User, Host: string);
    procedure SurfaceFtpRequest(Sender: TObject; User, Host, Path: string);
    procedure SurfaceDocument(Sender: TObject; Web: TWeb; DocClass,
      DocType: string; var AutoHandle: Boolean);
    procedure SurfaceInfo(Sender: TObject; TotalLength, BytesRead,
      Completed, DocCompleted: Integer);
    procedure ShowImages1Click(Sender: TObject);
    procedure SurfaceError(Sender: TObject; ErrorCode: Integer;
      ErrorMessage: string);
    procedure ShowToolBar1Click(Sender: TObject);
    procedure ShowSourceCode1Click(Sender: TObject);
    procedure SaveDocument1Click(Sender: TObject);
    procedure SurfaceSave(Sender: TObject; TotalImages,
      CurrentImage: Integer; DocName: string);
    procedure ShowToolBar2Click(Sender: TObject);
    procedure B1Click(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure ShowHeader1Click(Sender: TObject);
    procedure ClearCache1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FindWord1Click(Sender: TObject);
    procedure PrinterSetup1Click(Sender: TObject);
    procedure ShowStatusbar1Click(Sender: TObject);
    procedure WebNavigator1UrlChanged(Sender: TObject);
   private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  ProgDiag : TPrgDlg;
  GoList   : TStringList;
  BookList : TStringList;

implementation

uses prev;

{$R *.DFM}

procedure TMainForm.WebNavigator2Click(Sender: TObject;
  Button: TWebNavigateBtn);
var
   found : boolean;
begin
     case Button of

     nbOpen:
     begin
        WebNavigator1.UrlBox.Items.Add(WebNavigator1.Url);
        Surface.Retrieve(WebNavigator1.Url);
     end;

     nbStop:
     begin
        StatusBar1.Panels[0].Text := 'Document: Done.';
        Surface.Abort;
     end;

     nbBack:
     begin
         Surface.PageBack;
     end;

     nbForward:
     begin
         Surface.PageForward;
     end;

     nbPrint:
     begin
          Surface.Print;
     end;

     nbReload:
     begin
          Surface.Retrieve(WebNavigator1.Url);
     end;

     nbFind:
     begin
          FindWord1Click(Self);
     end;

     end;
end;

procedure TMainForm.SurfaceConnected(Sender: TObject; URL : string);
begin
     StatusBar1.Panels[0].Text := 'Host contacted. Requesting document...';
     StatusBar1.Panels[1].Text := 'Cache Size: ' + IntToStr(WebCache1.ActualSize);
     StatusBar1.Invalidate;
end;

procedure TMainForm.SurfaceURL(Sender: TObject);
begin
     StatusBar1.Panels[0].Text := Surface.ResultURL;
end;

procedure TMainForm.SurfaceUrlClick(Sender: TObject);
begin
     StatusBar1.Panels[0].Text := 'Contacting host....';
     Surface.Retrieve(Surface.ResultURL);
end;

procedure TMainForm.SurfaceDisconnected(Sender: TObject);
begin
     StatusBar1.Panels[0].Text := 'Document: Done';
     StatusBar1.Panels[1].Text := 'Cache Size: ' + IntToStr(WebCache1.ActualSize);
     StatusBar1.Invalidate;
end;

procedure TMainForm.SurfaceTitle(Sender: TObject; DocumentTitle: string);
begin
     Caption := 'SurfACE - ' + DocumentTitle;
end;

procedure TMainForm.OpenFile1Click(Sender: TObject);
var
   s : string;
begin
     OpenDialog1.Execute;
     s := OpenDialog1.FileName;
     if s <> '' then
          Surface.Retrieve(s);
end;

procedure TMainForm.ProxySetting1Click(Sender: TObject);
var
   p : TProxy;
   x : integer;
   Ini : TIniFile;
   nop : TStringList;
   s : string;
begin
     p := TProxy.Create(Application);
     p.Edit1.Text := WebProxy1.Http;
     p.Edit2.Text := IntToStr(WebProxy1.HttpPort);
     p.Memo1.Lines.Assign(WebProxy1.NoProxy);
     p.ShowModal;
     if p.ModalResult = mrOK then
          with WebProxy1 do
          begin
               Http := p.edit1.text;
               try
                  x := StrToInt(p.edit2.text);
               except
                  x := 0;
               end;
               HttpPort := x;
               WebProxy1.NoProxy.assign(p.memo1.Lines);
               if p.CheckBox1.checked then
               begin
                    SetAllProxyTo(p.edit1.text);
                    SetAllProxyPortTo(x);
               end;
          end;
     p.Release;

     nop := TStringList.Create;
     Ini := TIniFile.Create('SURFACE.INI');
     Ini.WriteString('Proxy','Http',WebProxy1.Http);
     Ini.WriteInteger('Proxy','HttpPort',WebProxy1.HttpPort);
     Ini.EraseSection ('No_Proxy');

     Nop.Assign(WebProxy1.NoProxy);

     { Create the 'nopxx' stuff }
     for x := 0 to Pred(Nop.Count) do
          Ini.WriteString('No_Proxy', 'NOP' + IntToStr(x), Nop.Strings[x]);

     Ini.free;
     Nop.free;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   Ini : TIniFile;
   nop : TStringList;
   x,
   p : integer;
   s : string;
begin
     GoList := TStringList.Create;
     BookList := TStringList.Create;
     nop := TStringList.Create;
     Ini := TIniFile.Create('SURFACE.INI');
     WebProxy1.Http := Ini.ReadString('Proxy','Http','');
     WebProxy1.HttpPort := Ini.ReadInteger('Proxy','HttpPort',0);
     Ini.ReadSection ('No_Proxy', Nop);
     Ini.free;
     { Get rid of 'nopxx' stuff }
     for x := 0 to Pred(Nop.Count) do
     begin
          s := Nop.Strings[x];
          p := Pos('=', s);
          s := Copy(s, Succ(p), Length(s)-p);
          Nop.Strings[x] := 'ti.com';
     end;
     WebProxy1.NoProxy.Assign(Nop);
     Nop.Free;

     { Asked by Major }
     { this is worth four beers (he's also correcting me)}
     width := MulDiv(Screen.Width,90,100);
     height := MulDiv(Screen.height,90,100);
     WebCache1.Initialize;
     StatusBar1.Panels[1].Text := 'Cache Size: ' + IntToStr(WebCache1.ActualSize);

end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TMainForm.Print1Click(Sender: TObject);
begin
     Surface.Print;
end;

procedure TMainForm.PrintPreview1Click(Sender: TObject);
begin
Preview := TPreview.Create(Application);
with Preview do
begin
     WebPreview1.Webprinter := WebPrinter1;
     Surface.CreatePreview;
     WebPreview1.Zoom := 75;
     WebPreview1.PageNumber := 1;
     ShowModal;
     WebPreview1.Webprinter := nil;
end;
Preview.Release;
end;

procedure TMainForm.SurfaceMailRequest(Sender: TObject; User,
  Host: string);
var
   f : TRForm;
begin
     f := TRForm.Create(Application);
     with f do
     begin
          Caption := 'Mail Request';
          Memo1.Lines.Add('User: ' + User);
          Memo1.Lines.Add('Host: ' + Host);
          ShowModal;
     end;
     f.Release;
end;

procedure TMainForm.SurfaceFtpRequest(Sender: TObject; User, Host,
  Path: string);
var
   f : TRForm;
begin
     f := TRForm.Create(Application);
     with f do
     begin
          Caption := 'FTP Request';
          Memo1.Lines.Add('User: ' + User);
          Memo1.Lines.Add('Host: ' + Host);
          Memo1.Lines.Add('Path: ' + Path);
          ShowModal;
     end;
     f.Release;
end;

procedure TMainForm.SurfaceDocument(Sender: TObject; Web: TWeb; DocClass,
  DocType: string; var AutoHandle: Boolean);
var
   undiag : TUnk;
   saveDoc : TSvDocDlg;
begin
     if (UpperCase(DocClass) <> 'IMAGE') and (UpperCase(DocClass) <> 'TEXT') then
     begin
          undiag := TUnk.Create(Application);
          with undiag do
          begin
               DocuClass.Caption := UpperCase(DocClass);
               DocuType.Caption := UpperCase(DocType);
               Memo1.Lines.Assign(Web.ResponseList);
               ShowModal;
               if ModalResult = mrOK then
               begin
                    Release;
                    SaveDoc := TSvDocDlg.Create(Application);
                    SaveDoc.SaveDialog1.FileName := Web.DocumentName;
                    SaveDoc.SaveDialog1.Execute;
                    if SaveDoc.SaveDialog1.FileName <> '' then
                    begin
                         AutoHandle := False;
                         SaveDoc.Web1 := Web;
                         SaveDoc.Label1.Caption := 'Saving to ' + SaveDoc.SaveDialog1.FileName;
                         SaveDoc.Label2.Caption := 'Transferring data...';
                         Web.OnContext1 := SaveDoc.Web1Context1;
                         Web.OnDisconnect := SaveDoc.Web1Disconnect;
                         SaveDoc.Show;
                         SaveDoc.KickDownLoading;
                    end
                    else
                    begin
                         SaveDoc.Release;
                         AutoHandle := False;
                    end;
               end;
         end;
     end;

end;

procedure TMainForm.SurfaceInfo(Sender: TObject; TotalLength, BytesRead,
  Completed, DocCompleted: Integer);
begin
     if Memo1.Visible then
        memo1.lines.assign(Surface.Header);
     if TotalLength <> 0 then
        StatusBar1.Panels[0].Text := 'Read ' + IntToStr(BytesRead) + ' of '
                       + IntToStr(TotalLength) +' bytes.' + ' (' + IntToStr(Completed)+'%)'
     else
        if BytesRead > 0 then
           StatusBar1.Panels[0].Text := 'Read ' + IntToStr(BytesRead) + ' bytes.'
        else
           StatusBar1.Panels[0].Text := 'Transferring data...';
end;

procedure TMainForm.ShowImages1Click(Sender: TObject);
begin
     ShowImages1.Checked := not ShowImages1.Checked;

     if ShowImages1.Checked then
     begin
        WebNavigator1.EnabledButtons := WebNavigator1.EnabledButtons - [nbImages];
        Surface.ShowImages := True;
        Surface.ReloadImages;
     end
     else
     begin
        WebNavigator1.EnabledButtons := WebNavigator1.EnabledButtons + [nbImages];
        Surface.ShowImages := False;
     end;
end;

procedure TMainForm.SurfaceError(Sender: TObject; ErrorCode: Integer;
  ErrorMessage: string);
begin
    MessageDlg(ErrorMessage, mtError, [mbOk], 0);
end;

procedure TMainForm.ShowToolBar1Click(Sender: TObject);
begin
     ShowToolBar1.Checked := not ShowToolBar1.Checked;
     Panel2.Visible := ShowToolBar1.Checked;
end;

procedure TMainForm.ShowSourceCode1Click(Sender: TObject);
var
   SourceDiag : TSourceDlg;
   Buffer: PChar;
   Size: integer;
begin
          SourceDiag := TSourceDlg.Create(Application);
          with SourceDiag do
          begin
               RichEdit1.Lines.Clear;
               RichEdit1.SetTextBuf(PChar(Surface.Source));
               ShowModal;
               if ModalResult = mrOK then
               begin
                    Size := RichEdit1.GetTextLen;
                    Inc(Size);
                    GetMem(Buffer, Size);
                    RichEdit1.GetTextBuf(Buffer,Size);
                    Surface.Source := buffer;
                    FreeMem(Buffer, Size);
                    Surface.ParseBuffer;
               end;
               Release;
         end;
end;

procedure TMainForm.SaveDocument1Click(Sender: TObject);
var
   SaveDiag : TSaveDlg;
   x : integer;
   s : string;
begin
          SaveDiag := TSaveDlg.Create(Application);
          ProgDiag := TPrgDlg.Create(Application);
          with SaveDiag do
          begin
               ShowModal;
               if ModalResult = mrOK then
               begin
                    s := Surface.Host;
                    for x := 1 to Length(s) do
                        if s[x] = '.' then s[x] := '_';
                    s := s + '.html';
                    SaveDialog1.FileName := s;
                    SaveDialog1.Execute;
                    if SaveDialog1.FileName <> '' then
                    begin
                         ProgDiag.Show;
                         Surface.SaveDocument(ExtractFilePath(SaveDialog1.FileName),
                                              ExtractFileName(SaveDialog1.FileName),
                                              CheckBox1.Checked,
                                              CheckBox2.Checked);

                    end;
               end;
               ProgDiag.Release;
               Release;
         end;
end;

procedure TMainForm.SurfaceSave(Sender: TObject; TotalImages,
  CurrentImage: Integer; DocName: string);
begin
     if (TotalImages = 0) then
        ProgDiag.Panel1.Caption := 'Saving HTML document: ' + DocName
     else
     begin
          ProgDiag.Panel1.Caption := 'Saving Image ' + DocName + '(Image ' +
                                    IntToStr(CurrentImage) + ' of ' + IntToStr(TotalImages);
          ProgDiag.ProgressBar1.Position := MulDiv(CurrentImage, 100, TotalImages);

     end;
     Application.ProcessMessages;
end;

procedure TMainForm.ShowToolBar2Click(Sender: TObject);
begin
     ShowToolBar2.Checked := not ShowToolBar2.Checked;
     Panel4.Visible := ShowToolBar2.Checked;

end;

procedure TMainForm.B1Click(Sender: TObject);
var
   s : string;
   x : integer;
begin
   StatusBar1.Panels[0].Text := 'Contacting host....';
   s := TButton(Sender).Name;
   x := StrToInt(Copy(s,2,1));
   case x of
        1: Surface.Retrieve('www.solution6.com.au');
        2: Surface.Retrieve('www.mel.aone.net.au');
        3: Surface.Retrieve('www.transerve.com');
        4: Surface.Retrieve('www.stockmaster.com');
        5: Surface.Retrieve('cnn.com');
   end;
end;

procedure TMainForm.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
    x: integer;
begin
     if Surface.TotalImages > 0 then
     begin
         x := Rect.Right - Rect.Left;
         StatusBar1.Canvas.Brush.Color := clRed;
         StatusBar1.Canvas.Brush.Style := bsSolid;
         StatusBar1.Canvas.Rectangle(Rect.Left, Rect.Top,
                                          Rect.Left + MulDiv(Surface.Loaded,
                                                             x,
                                                             Surface.TotalImages),
                                          Rect.Bottom);
     end;
end;

procedure TMainForm.ShowHeader1Click(Sender: TObject);
begin
     ShowHeader1.Checked := not ShowHeader1.Checked;
     Memo1.Visible := ShowHeader1.Checked;
end;

procedure TMainForm.ClearCache1Click(Sender: TObject);
begin
     WebCache1.ClearCache;
     StatusBar1.Panels[1].Text := 'Cache Size: ' + IntToStr(WebCache1.ActualSize);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
     GoList.Free;
     BookList.free;
end;

procedure TMainForm.FindWord1Click(Sender: TObject);
var
   SrchDlg : TFomdDlg;
begin
          SrchDlg := TFomdDlg.Create(Application);
          SrchDlg.Show;
end;

procedure TMainForm.PrinterSetup1Click(Sender: TObject);
begin
     PrinterSetupDialog1.Execute;
end;

procedure TMainForm.ShowStatusbar1Click(Sender: TObject);
begin
     ShowStatusbar1.Checked := not ShowStatusbar1.Checked;
     StatusBar1.Visible := ShowStatusbar1.Checked;
end;

procedure TMainForm.WebNavigator1UrlChanged(Sender: TObject);
begin
        StatusBar1.Panels[0].Text := 'Contacting host....';
end;

end.
