unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, WebBrow, Result;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Button1: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ListBox2: TListBox;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure WebBrowser1DocumentAvailable(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox2DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FName : string;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
     if OpenDialog1.Execute then
     begin
          if OpenDialog1.FileName <> '' then
             Fname := OpenDialog1.FileName;
          WebBrowser1.Retrieve(Fname);
     end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     ListBox1.Items.Add(Edit1.Text);
     Edit1.Text := '';
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   x : integer;
begin
     for x := Pred(ListBox1.Items.Count) downto 0 do
          if ListBox1.Selected[x] then
               ListBox1.Items.Delete(x);
end;

procedure TForm1.Button4Click(Sender: TObject);
var
   x : integer;
begin
     WebBrowser1.ExtractList.Clear;
     WebBrowser1.ExtractWordList.Clear;
     for x := 0 to Pred(ListBox1.Items.Count) do
         if Pos(#255, ListBox1.Items[x]) > 0 then
            WebBrowser1.ExtractWordList.Add(ListBox1.Items[x])
         else
            WebBrowser1.ExtractList.Add(ListBox1.Items[x]);

     if FName <> '' then
        WebBrowser1.Retrieve(FName);
end;

procedure TForm1.WebBrowser1DocumentAvailable(Sender: TObject);
begin
ListBox2.Items.Assign(WebBrowser1.TextList);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
FName := '';
end;

procedure TForm1.Button7Click(Sender: TObject);
var
   x,
   y : integer;
   v1,
   v2 : integer;
   s1,
   s2 : string;
begin
     if CheckBox1.Checked then
     begin
          for x := 0 to Pred(ListBox2.Items.Count) do
               if ListBox2.Selected[x] then
               begin
                    v1 := x;
                    break;
               end;

          for x := Pred(ListBox2.Items.Count) downto 0 do
               if ListBox2.Selected[x] then
               begin
                    v2 := x;
                    break;
               end;

          if (v2 - v1) >= 1 then
          begin
               s1 := ListBox2.Items[v1];
               x := Pos(' ', s1);
               s2 := ListBox2.Items[v2];
               y := Pos(' ', s2);
               if (x > 0) and (y > 0) then
               begin
                    s1 :=  Copy(s1, Succ(x), Length(s1) - x);
                    s2 :=  Copy(s2, Succ(y), Length(s2) - y);
                    ListBox1.Items.Add(s1+#255+s2);
               end;
          end;
     end
     else
     begin
          for x := 0 to Pred(ListBox2.Items.Count) do
          begin
               if ListBox2.Selected[x] then
               begin
                    s1 := ListBox2.Items[x];
                    v1 := Pos('[', s1);
                    v2 := Pos(']', s1);
                    if (v1 > 0) and (v2 > 0) then
                    begin
                         s2 := Copy(s1, Succ(v1), v2-2);
                         ListBox1.Items.Add(s2);
                    end;
               end;
          end;
     end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
   res : TResultDlg;
   x : integer;
begin
   res := TResultDlg.Create(Application);
   with res do
   begin
     Memo1.Clear;
     Memo2.Clear;
     for x := 0 to Pred(ListBox1.Items.Count) do
         if Pos(#255, ListBox1.Items[x]) > 0 then
            Memo1.Lines.Add(ListBox1.Items[x])
         else
            Memo2.Lines.Add(ListBox1.Items[x]);
     ShowModal;
   end;
   Res.Release;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
     if key = #13 then
     begin
          key := #0;
          Button2Click(Self);
     end;
end;

procedure TForm1.ListBox2DblClick(Sender: TObject);
var
   x : integer;
   s1,
   s2 : string;
   v1,
   v2 : integer;
begin
     if ListBox2.ItemIndex >= 0 then
     begin
          s1 := ListBox2.Items[ListBox2.ItemIndex];
          v1 := Pos('[', s1);
          v2 := Pos(']', s1);
          if (v1 > 0) and (v2 > 0) then
          begin
               s2 := Copy(s1, Succ(v1), v2-2);
               ListBox1.Items.Add(s2);
          end;
     end;
end;
end.
