unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, WebBrow, StdCtrls, ExtCtrls, Tabnotbk, Web, WebNav;

type
  TForm1 = class(TForm)
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    TabbedNotebook1: TTabbedNotebook;
    Label1: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Panel3: TPanel;
    WebBrowser1: TWebBrowser;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Button2: TButton;
    Button3: TButton;
    Web1: TWeb;
    Panel6: TPanel;
    Label6: TLabel;
    CheckBox3: TCheckBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Label7: TLabel;
    Panel7: TPanel;
    WebNavigator1: TWebNavigator;
    WebBrowser2: TWebBrowser;
    Bevel1: TBevel;
    Bevel2: TBevel;
    procedure Web1Connect(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Web1DataAvailable(Sender: TObject; Buffer: PChar;
      Len: Integer);
    procedure Web1Disconnect(Sender: TObject);
    procedure Web1Redirection(sender: TObject; Location: string);
    procedure WebBrowser1DocumentAvailable(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure TabbedNotebook1Click(Sender: TObject);
  private
    { Private declarations }
    procedure CheckTree(FPath : string);
    function GetBack(s : string) : string;
    procedure DownloadImages;
    procedure DownloadLinks;
  public
    { Public declarations }
  end;

var
  Form1      : TForm1;
  MPath      : string;
  MFile      : string;
  HTMLDoc    : string;
  OldDir     : string;
  SiteSize   : longint;
  Links,
  Images     : TStringList;
  DocFlag    : boolean;
  ImageIndex : integer;
  LinkIndex  : integer;

implementation

{$R *.DFM}

procedure TForm1.Web1Connect(Sender: TObject);
begin
     Panel5.Caption := 'Host ' + UpperCase(Web1.WebHost) + ' contacted';
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   s : string;
   x : Integer;
begin
if Button2.Caption = 'Start' then
begin
     if Edit1.Text <> '' then
     begin
        s := Edit1.Text;
        for x := 0 to Length(s) do
            if s[x] = '.' then s[x] := '_';
        s := s + '.html';
        SaveDialog1.Filename := s;
        if SaveDialog1.Execute and (SaveDialog1.FileName <> '') then
        begin
          MPath := ExtractFilePath(SaveDialog1.FileName);
          MFile := ExtractFileName(SaveDialog1.FileName);
          Links.Clear;
          Images.Clear;
          ImageIndex := 0;
          LinkIndex := 0;
          Links.Add(Edit1.Text);
          DocFlag := False;
          OldDir := GetCurrentDir;
          SetCurrentDir(MPath);
          SiteSize := 0;
          if CheckBox3.Checked then
          begin
               with Web1 do
               begin
                    UseProxy := True;
                    Proxy := Edit2.Text;
                    ProxyPort := StrToInt(Edit3.Text);
               end;
          end
          else
              Web1.UseProxy := False;
          Button2.Caption := 'Stop';
          DownloadLinks;
        end;
     end;
end
else
begin
     If Web1.Retrieving then Web1.Abort;
     Panel4.Caption := '';
     Panel5.Caption := 'Idle';
     Button2.Caption := 'Start';
end;
end;

procedure TForm1.Web1DataAvailable(Sender: TObject; Buffer: PChar;
  Len: Integer);
begin
     if not DocFlag then
        HTMLDoc := HTMLDoc + string(Buffer);
     Panel5.Caption := 'Retrieving document ' +
                       Web1.DocumentName + ' [' + IntToStr(Web1.Size) + ' bytes read]';
     Inc(SiteSize, Len);
     Panel6.Caption := IntToStr(SiteSize);
end;

procedure TForm1.Web1Disconnect(Sender: TObject);
begin
     Panel5.Caption := 'Server at ' + UpperCase(Web1.WebHost) + ' has closed communication';
     if not DocFlag then
     begin
          WebBrowser1.Source := HTMLDoc;
          WebBrowser1.Host := Web1.WebHost;
          WebBrowser1.Path := Web1.DocumentPath;
          WebBrowser1.ParseBuffer;
          DocFlag := True;
     end
     else
          if ImageIndex < Images.Count then
          begin
             SetCurrentDir(OldDir);
             DownloadImages;
          end
          else
          begin
               Panel4.Caption := '';
               Panel5.Caption := 'Idle';
               Button2.Caption := 'Start';
          end;
end;

procedure TForm1.Web1Redirection(sender: TObject; Location: string);
begin
     Panel5.Caption := 'Redirecting to ' + Location;
     Web1.Url := Location;
     Web1.Retrieve;
end;

procedure TForm1.WebBrowser1DocumentAvailable(Sender: TObject);
begin
     Panel5.Caption := 'Saving links';
     Links := WebBrowser1.Links;
     Images := WebBrowser1.Images;

     Panel2.Caption := IntToStr(Links.Count);
     Panel3.Caption := IntToStr(Images.Count);

     if (CheckBox1.Checked) and (Images.Count > 0) then
     begin
        ImageIndex := 0;
        DownLoadImages;
     end
end;

procedure TForm1.DownloadLinks;
begin
        Panel4.Caption := 'Downloading Link';
        begin
             Panel2.Caption := IntToStr(Succ(LinkIndex)) + ' of ' + IntToStr(Links.Count);
             Panel4.Caption := Links.Strings[LinkIndex];
             Web1.Url := Links.Strings[LinkIndex];
             Web1.SaveToFile := True;
             if CheckBox2.Checked then
             begin
                CheckTree(Web1.DocumentPath);
                SetCurrentDir(GetCurrentDir + GetBack(Web1.DocumentPath));
             end;

                if Web1.DocumentName <> '' then
                   Web1.FileName := Web1.DocumentName
                else
                    Web1.FileName := MFile;

             if CheckBox2.Checked then
                CheckTree(Web1.DocumentPath);
             Inc(LinkIndex);
             HTMLDoc := '';
             Panel5.Caption := 'Contacting host ' + UpperCase(Web1.WebHost);
             Web1.Retrieve;
        end;
end;

procedure TForm1.DownloadImages;
begin
        Panel4.Caption := 'Downloading Images';
        begin
             Panel3.Caption := IntToStr(Succ(ImageIndex)) + ' of ' + IntToStr(Images.Count);
             Panel4.Caption := Images.Strings[ImageIndex];
             Web1.Url := Images.Strings[ImageIndex];
             Web1.SaveToFile := True;
             if CheckBox2.Checked then
                CheckTree(Web1.DocumentPath);

             if CheckBox2.Checked then
             begin
                Web1.FileName := Web1.DocumentName;
                SetCurrentDir(GetCurrentDir + GetBack(Web1.DocumentPath));
             end
             else
                 Web1.FileName := Web1.DocumentName;
             if CheckBox2.Checked then
                CheckTree(Web1.DocumentPath);

             Panel5.Caption := 'Contacting host ' + UpperCase(Web1.WebHost);
             Inc(ImageIndex);
             Web1.Retrieve;
        end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     Links := TStringList.Create;
     Images := TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     Links.Free;
     Images.free;
end;

procedure TForm1.CheckTree(FPath : string);
var
   x : integer;
   p : TStringList;
   s : string;
   od : string;
begin
     p := TStringList.Create;

     { break the path into various directories }
     s := '';
     for x := 1 to Length(FPath) do
     begin
          if FPath[x] = '/' then
          begin
               p.Add(s);
               s := '';
          end
          else
              s := s + FPath[x];
     end;

     od := GetCurrentDir;

     { starting from the current path check the existence of each sub dir }
     for x := 0 to Pred(p.Count) do
          if not SetCurrentDir(p.Strings[x]) then
          begin
               CreateDir(p.Strings[x]);
               SetCurrentDir(p.Strings[x]);
          end;
     SetCurrentDir(od);
end;

function TForm1.GetBack(s : string) : string;
var
   x : integer;
begin
     Result := '';
     for x := 1 to Length(s) do
         if s[x] = '/' then s[x] := '\';
     Result := s;
end;
procedure TForm1.Button3Click(Sender: TObject);
begin
     if Web1.Retrieving then Web1.Abort;
     Application.Terminate;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
     Edit2.Enabled := CheckBox3.Checked;
     Edit3.Enabled := CheckBox3.Checked;
end;

procedure TForm1.TabbedNotebook1Click(Sender: TObject);
begin
if TabbedNotebook1.PageIndex = 1 then
     WebBrowser2.Retrieve(MPath+MFile);
end;

end.
