unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons,
  Web, WebImage;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    Button1: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    Label3: TLabel;
    ComboBox1: TComboBox;
    WebImage1: TWebImage;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure WebImage1Connect(Sender: TObject);
    procedure WebImage1Read(Sender: TObject);
    procedure WebImage1Disconnect(Sender: TObject);
    procedure EnableBTN;
    procedure DisableBTN;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure WebImage1Error(Sender: TObject; ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    procedure ComposeUrl(s : string);
    procedure GetIt;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  sgif  : string;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
  Panel2.caption := 'Idle';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     if Length(ComboBox1.text) <= 0 then
        WebImage1Error(Self,0)
     else
     begin
          ComposeUrl('vg');
          GetIt;
     end;
end;

procedure TForm1.GetIt;
begin
     DisableBTN;
     Panel2.caption := 'Connecting...';
     Application.ProcessMessages;
     WebImage1.Url := sgif;
     WebImage1.Alternate := Uppercase(ComboBox1.text[4]); {works only for 4 char codes}
     WebImage1.Visible := True;
     WebImage1.Retrieve;
end;

procedure TForm1.EnableBTN;
begin
     Button1.Enabled  := True;
     Button2.Enabled  := True;
     Button3.Enabled  := True;
     Screen.Cursor := crDefault;
end;

procedure TForm1.DisableBTN;
begin
     Button1.Enabled  := False;
     Button2.Enabled  := False;
     Button3.Enabled  := False;
     Screen.Cursor := crHourGlass;
end;

procedure TForm1.WebImage1Connect(Sender: TObject);
begin
     Panel2.caption := 'Connected';
end;

procedure TForm1.WebImage1Read(Sender: TObject);
begin
     Panel2.caption := 'Reading...';
end;

procedure TForm1.WebImage1Disconnect(Sender: TObject);
begin
     Panel2.caption := 'Idle';
     EnableBTN;
end;

procedure TForm1.ComposeURL(s : string);
var
   u : string;
begin

     case ComboBox1.ItemIndex of
       0: u := 'BORL';
       1: u := 'MSFT';
       2: u := 'NSCP';
       3: u := 'NETM';
       4: u := 'IBM';
     else
       u := UpperCase(ComboBox1.text);
     end;

     sgif := 'http://www.stockmaster.com/sm/' +
             s + '/' + u[1] + '/' + u + '.gif';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     if Length(ComboBox1.text) <= 0 then
        WebImage1Error(Self,0)
     else
     begin
          ComposeUrl('pg');
          GetIt;
     end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TForm1.WebImage1Error(Sender: TObject; ErrorCode: Integer);
begin
          MessageDlg('Invalid ticker', mtInformation,
           [mbOk], 0);
           EnableBTN;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     Form1.Print;
end;

end.
