unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, WebBrow;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Button1: TButton;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    PaintBox5: TPaintBox;
    PaintBox3: TPaintBox;
    PaintBox2: TPaintBox;
    PaintBox4: TPaintBox;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure WebBrowser1Disconnected(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ScrollBar1Change(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  bmp : TBitmap;
  zoom : integer;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
webbrowser1.Retrieve(ExtractFilePath(ParamStr(0))+'wt.html');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
bmp := TBitmap.Create;
Bmp.monochrome := False;
zoom := 40;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     bmp.free;
end;

procedure TForm1.WebBrowser1Disconnected(Sender: TObject);
begin
     WebBrowser1.GetShot(Bmp);
     with PaintBox1 do
     begin
          Canvas.StretchDraw(Rect(0,0,Width,Height), Bmp);
          PaintBox1MouseMove(Self,[], 20,20);
     end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   tmp : TBitmap;
   x1, y1 : integer;
   px : trect;
   pz : trect;
   py : trect;
begin
     x1 := Round(Bmp.Width / PaintBox1.Width * x);
     y1 := Round(Bmp.Height / PaintBox1.Height * y);

     tmp := TBitmap.Create;
     with tmp do
     begin
          width := zoom;
          height := zoom;
          monochrome := false;
     end;
     tmp.Canvas.CopyRect(Rect(0,0,zoom,zoom),
                         Bmp.Canvas,
                         Rect(x1-zoom div 2,y1-zoom div 2,x1+zoom div 2,y1+zoom div 2));


     with PaintBox3 do
          Canvas.StretchDraw(Rect(0,0,width,height), tmp);
     with PaintBox4 do
          Canvas.StretchDraw(Rect(0,0,width,height), tmp);
     with PaintBox2 do
          Canvas.StretchDraw(Rect(0,0,width,height), tmp);
     with PaintBox5 do
          Canvas.StretchDraw(Rect(0,0,width,height), tmp);
     tmp.free;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
     zoom := ScrollBar1.Position;
     Label1.Caption := 'Zoom: ' + IntToStr(Zoom);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
     with PaintBox1 do
          Canvas.StretchDraw(Rect(0,0,Width,Height), Bmp);
end;

end.
